<?php
require("auth.php");

$DBH = null;
function db_init() {
	global $DBH;
	$DBH = new PDO("mysql:unix_socket=/run/mysqld/mysqld.sock;dbname=chat", "chat", "=~ZQ@Snw%KuW,q2", array(PDO::MYSQL_ATTR_INIT_COMMAND => "SET NAMES 'utf8'"));
	$DBH->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
}
if(isset($_POST['action']) && isset($_POST['data'])) {
	db_init();
	$data = json_decode($_POST['data'], true);

	if($_POST['action'] == "save-text") {
		try {
			$DBH->beginTransaction();
			$stmt = $DBH->prepare("UPDATE tmp_buttons SET text = ? WHERE button_id = ?");
			if (!$stmt->execute([$data[0]['text'], $data[0]['id']])) {
				$DBH->rollback();
				die("sql error!");
			}
			$DBH->commit();
		} catch (Exception $e) {
			$DBH->rollBack();
			die("sql error!");
		}
		die("OK");
	}
	if($_POST['action'] == "apply") {
		$DBH->exec("TRUNCATE `buttons`");
		$DBH->exec("INSERT INTO buttons SELECT * FROM tmp_buttons");
		die("OK");
	}
	if($_POST['action'] == "reset") {
		$DBH->exec("TRUNCATE `tmp_buttons`");
		$DBH->exec("INSERT INTO tmp_buttons SELECT * FROM buttons");
		die("OK");
	}
	$texts = [];
	try {
		foreach($DBH->query('SELECT button_id, text FROM tmp_buttons') as $row) {
			$texts[$row['button_id']] = $row['text'];
		}
		$DBH->exec("TRUNCATE `tmp_buttons`");
		$DBH->beginTransaction();
		$stmt = $DBH->prepare("INSERT INTO `tmp_buttons` (`button_id`, `parent`, `name`, `color`, `line`, `text`) VALUES (?, ?, ?, ?, ?, ?)");

		foreach($data as $line) {
			$parent = 0;
			$text = "";
			if(isset($line['parent'])) {
				$parent = $line['parent'];
			}
			if(isset($texts[$line['id']])) {
				$text = $texts[$line['id']];
			}
			if(!isset($line['id']) || !isset($line['name']) || !isset($line['color']) || !isset($line['line'])) {
				continue;
			}
			if (!$stmt->execute([$line['id'], $parent, $line['name'], $line['color'], (int)$line['line'], $text])) {
				$DBH->rollback();
				die("sql error!");
			}
		}
		$DBH->commit();
	} catch (Exception $e) {
		$DBH->rollBack();
		die("sql error!");
	}
	die("OK");
}
?>
<!doctype html>
<html lang="ru">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  <title>Админка</title>
  <link rel="stylesheet" href="/bootstrap.min.css">
  <script src="/jquery.min.js"></script>
  <script src="/bootstrap.bundle.min.js"></script>
  <script src="/jquery.treegrid.min.js"></script>
  <link rel="stylesheet" href="/jquery.treegrid.css">
  <style>
label {
	margin: 0;
	padding: 0;
}
.form_radio_group {
	display: inline-block;
	overflow: hidden;
	margin: 0;
	padding: 0;
}
.form_radio_group-item {
	display: inline-block;
	float: left;
	margin: 0;
	padding: 0;
}
.form_radio_group input[type=radio] {
	display: none;
}
.form_radio_group label {
	display: inline-block;
	cursor: pointer;
	margin: 0;
	padding: 0px 15px;
	line-height: 34px;
	border: 1px solid #999;
	border-right: none;
	user-select: none;
}
.form_radio_group .form_radio_group-item:first-child label {
	border-radius: 6px 0 0 6px;
}
.form_radio_group .form_radio_group-item:last-child label {
	border-radius: 0 6px 6px 0;
	border-right: 1px solid #999;
}
.radio-1 {
	background: #447BBA;
}
.radio-2 {
	background: #EBF2FA;
}
.radio-3 {
	background: #E64646;
}
.radio-4 {
	background: #4BB34B;
}
.form_radio_group label:hover {
	color: #666;
}
.custom-checkbox {
  position: absolute;
  z-index: -1;
  opacity: 0;
}
.custom-checkbox+label {
  display: inline-flex;
  align-items: center;
  user-select: none;
}
.custom-checkbox+label::before {
  content: '';
  display: inline-block;
  width: 1em;
  height: 1em;
  flex-shrink: 0;
  flex-grow: 0;
  border: 1px solid #adb5bd;
  border-radius: 0.25em;
  margin-right: 0.5em;
  background-repeat: no-repeat;
  background-position: center center;
  background-size: 50% 50%;
}
.custom-checkbox:checked+label::before {
  border-color: #0b76ef;
  background-color: #0b76ef;
  background-image: url("data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 8 8'%3e%3cpath fill='%23fff' d='M6.564.75l-3.59 3.612-1.538-1.55L0 4.26 2.974 7.25 8 2.193z'/%3e%3c/svg%3e");
}
.custom-checkbox:not(:disabled):not(:checked)+label:hover::before {
  border-color: #b3d7ff;
}
.custom-checkbox:not(:disabled):active+label::before {
  background-color: #b3d7ff;
  border-color: #b3d7ff;
}
.custom-checkbox:focus+label::before {
  box-shadow: 0 0 0 0.2rem rgba(0, 123, 255, 0.25);
}
.custom-checkbox:focus:not(:checked)+label::before {
  border-color: #80bdff;
}
.custom-checkbox:disabled+label::before {
  background-color: #e9ecef;
}
#container{
    height:80vh;
}

#editor {
    width: 100%;
    height: 100%;
    position: relative;
}
  </style>
</head>
<body>
<div class="container">
<?php
if(isset($_GET['id'])) {
db_init();
$stmt = $DBH->prepare('SELECT name, text FROM tmp_buttons WHERE button_id = ?');
$stmt->execute([$_GET['id']]);
$res = $stmt->fetch(PDO::FETCH_ASSOC);
$name = $res['name'];
$text = $res['text'];
?>
	<h1 align="center">Редактор вывода кнопки <?=$name?></h1>
	<p class="lead text-center">На этой странице задаётся текст бота, который будет выдан после нажатия на кнопку <?=$name?>.</p>
<div id="container">
    <div id="editor"><?=$text?></pre>
</div>

	<div class="row">
		<div class="col-4" style="margin-bottom: 20px;"><a href="#" class="btn btn-success">Сохранить</a></div>
		<div class="col-4" style="margin-bottom: 20px;"><a href="#" class="btn btn-primary">Назад</a></div>
	</div>

	<script src="/src-noconflict/ace.js" type="text/javascript" charset="utf-8"></script>
	<script>
var editor = ace.edit("editor");
editor.setTheme("ace/theme/dawn");
editor.getSession().setMode("ace/mode/text");
$(document).ready(function() {
	$('.btn-success').click(function(e) {
		e.preventDefault();
		var out = [{"id": <?=$_GET['id']?>, "text": editor.getValue()}];
		$.post("/", {
			action: "save-text",
			data: JSON.stringify(out),
		}, function(data, status) {
			if(data != "OK") {
				alert("Ошибка сервера: "+data+"\n\nСтраница будет перезагружена.");
				location.reload();
			} else {
				document.location.href = '/';
			}
		}).fail(function(xhr, status, error) {
			alert("Сервер вернул ошибку: "+error+"\n\nСтраница будет перезагружена.");
			location.reload();
		});
	});
	$('.btn-primary').click(function(e) {
		e.preventDefault();
		document.location.href = '/';
	});
});
	</script>
<?php
} else {
?>
	<h1 align="center">Редактор меню бота</h1>
	<p class="lead text-center">Здесь задаются все кнопки бота.</p>

<table class="table table-bordered tree">
	<tbody>
<?php
db_init();
foreach($DBH->query('SELECT button_id, parent, name, color, line FROM tmp_buttons') as $row) {
	$parent = "";
	if($row['parent'] != 0) {
		$parent = " treegrid-parent-".$row['parent'];
	}
	echo ''.
'		<tr class="treegrid-'.$row['button_id'].$parent.'"><td><label>'.$row['name'].'</label></td><td>'.$row['color'].' '.$row['line'].'</td><td></td><td></td></tr>'.PHP_EOL;
}
?>
	</tbody>
</table>

<div style="margin-bottom: 20px;"><a href="#" class="tree-add-root btn btn-primary">Добавить кнопку</a></div>
<div class="row">
	<div class="col-4" style="margin-bottom: 20px;"><a href="#" class="btn btn-success">Применить</a></div>
	<div class="col-4" style="margin-bottom: 20px;"><a href="#" class="btn btn-danger">Отменить</a></div>
</div>

<script>

function foreachEditable() {
	$('.tree').children().children().each(function () {
		var id = $(this).prop('class').split(" ")[0].slice(9);
		var info = $(this).children('td').eq(1).text();
		if(info.length == 0) {
			info = '1 0';
		}
		if(info.length == 3) {
			info = info.split(" ");
			var one_checked, two_checked, three_cheched, four_checked, line_checked;
			switch(info[0]) {
				case "1":
					one_checked = 'checked';
					$(this).children('td').eq(0).css({'color': '#EBF2FA', 'background': '#447BBA'})
				break;
				case "2":
					two_checked = 'checked';
					$(this).children('td').eq(0).css({'color': '#447BBA', 'background': '#EBF2FA'})
				break;
				case "3":
					three_cheched = 'checked';
					$(this).children('td').eq(0).css({'color': '#EBF2FA', 'background': '#E64646'});
				break;
				case "4":
					four_checked = 'checked';
					$(this).children('td').eq(0).css({'color': '#EBF2FA', 'background': '#4BB34B'});
				break;
			}
			if(info[1] == 1) {
				line_checked = 'checked';
			}
			$(this).children('td').eq(1).css({'margin': 0, 'padding': 0});
			$(this).children('td').eq(1).html(''+
'	<div class="form_radio_group">'+
'		<div class="form_radio_group-item">'+
'			<input id="radio-1-'+id+'" type="radio" name="radio-'+id+'" value="1" '+one_checked+'>'+
'			<label for="radio-1-'+id+'" class="radio-1">■</label>'+
'		</div>'+
'		<div class="form_radio_group-item">'+
'			<input id="radio-2-'+id+'" type="radio" name="radio-'+id+'" value="2" '+two_checked+'>'+
'			<label for="radio-2-'+id+'" class="radio-2">■</label>'+
'		</div>'+
'		<div class="form_radio_group-item">'+
'			<input id="radio-3-'+id+'" type="radio" name="radio-'+id+'" value="3" '+three_cheched+'>'+
'			<label for="radio-3-'+id+'" class="radio-3">■</label>'+
'		</div>'+
'		<div class="form_radio_group-item">'+
'			<input id="radio-4-'+id+'" type="radio" name="radio-'+id+'" value="4" '+four_checked+'>'+
'			<label for="radio-4-'+id+'" class="radio-4">■</label>'+
'		</div>'+
'		<div class="form_radio_group-item">'+
'			<input type="checkbox" class="custom-checkbox" id="chk-'+id+'" value="" '+line_checked+'>'+
'			<label for="chk-'+id+'">Новая строка</label>'+
'		</div>'+
'	</div>');
		}
		if($(this).children().first().children().children().first().prop('class').split(" ").length == 1) {
			$(this).children('td').eq(2).html('<a href="/?id='+id+'" class="tree-edit-node">Редактировать</a>');
			$(this).children('td').eq(3).html('<a href="#" class="tree-remove-node">Удалить</a>');
		} else {
			$(this).children('td').eq(2).empty();
			$(this).children('td').eq(3).empty();
		}
	});
	$('input[type=radio]').change(function() {
		switch(this.value) {
			case "1":
				$(this).parent().parent().parent().parent().children().first().css({'color': '#EBF2FA', 'background': '#447BBA'});
			break;
			case "2":
				$(this).parent().parent().parent().parent().children().first().css({'color': '#447BBA', 'background': '#EBF2FA'});
			break;
			case "3":
				$(this).parent().parent().parent().parent().children().first().css({'color': '#EBF2FA', 'background': '#E64646'});
			break;
			case "4":
				$(this).parent().parent().parent().parent().children().first().css({'color': '#EBF2FA', 'background': '#4BB34B'});
			break;
		}
		sendTable();
	});
	$('input[type=checkbox]').change(function() {
		sendTable();
	});
}
function inputToLabel(e){
	$('.tree').data('treegrid-settings').enableMove = true;
	enableMove = true;
	var text = $(this).prop('value');
	$(this).replaceWith(function(){
		return $('<label>'+text+'</label>');
	});
	loadEvents();
	sendTable();
}
function sendTable(action) {
	if (action === undefined) {
		action = 'save';
	} 
	var out = [];
	$('.tree').children().children().each(function () {
		var classValues = $(this).prop('class').split(" ");
		var classValuesLen = classValues.length;
		switch(classValuesLen) {
			case 3:
			case 2:
				if(classValues[1] != "expanded") {
					out.push({"id": classValues[0].slice(9), "name": $(this).children().first().children().children().last().text(), "parent": classValues[1].slice(16), "color": $(this).children('td').find('input[type=radio]:checked').prop('value'), "line": $(this).children('td').find('input[type=checkbox]').prop('checked')});
					break;
				}
			case 1:
				out.push({"id": classValues[0].slice(9), "name": $(this).children().first().children().children().last().text(), "color": $(this).children('td').find('input[type=radio]:checked').prop('value'), "line": $(this).children('td').find('input[type=checkbox]').prop('checked')});
		}
	});
	$.post("/", {
		action: action,
		data: JSON.stringify(out),
	}, function(data, status) {
		if(data != "OK") {
			alert("Ошибка сервера: "+data+"\n\nСтраница будет перезагружена.");
			location.reload();
		} else if(action == "reset") {
			location.reload();
		}
	}).fail(function(xhr, status, error) {
		alert("Сервер вернул ошибку: "+error+"\n\nСтраница будет перезагружена.");
		location.reload();
    });
}
var enableMove = true;
function loadEvents() {
	$("*").unbind();
	$('.tree').treegrid({
		enableMove: enableMove,
		onMoveEnd: function() {
			loadEvents();
			sendTable();
		}
	});
	foreachEditable();
	$('.tree-add-root').click(function(e) {
		e.preventDefault();
		$('.tree').treegrid('add', ['<tr class="treegrid-'+Date.now()+'"><td><label>Новая кнопка</label></td><td>1 0</td><td></td><td></td></tr>']);
		loadEvents();
		sendTable();
	});
	$('.btn-success').click(function(e) {
		e.preventDefault();
		sendTable("apply");
		alert("Изменения успешно применены.");
	});
	$('.btn-danger').click(function(e) {
		e.preventDefault();
		sendTable("reset");
	});
	$('.tree-remove-node').click(function(e) {
		e.preventDefault();
		$(this).closest('tr').treegrid('remove');
		loadEvents();
		sendTable();
	});
	$('.treegrid-container>label').dblclick(function(e){
		$('.tree').data('treegrid-settings').enableMove = false;
		enableMove = false;
		var text = $(this).text();
		var lenText = text.length * 2;
		$(this).replaceWith(function(){
			return $('<input type="text" class="edit-text" value="'+text+'"></input>');
		});
		$('.edit-text').focus();
		$('.edit-text')[0].setSelectionRange(lenText, lenText);
		loadEvents();
	});
	$('.edit-text').blur(inputToLabel);
	$('.edit-text').bind("enterKey", inputToLabel);
	$('.edit-text').keyup(function(e) {
    if(e.keyCode == 13) {
        $(this).trigger("enterKey");
    }
});
};
$(document).ready(function() {
	loadEvents();
});

</script>

<?php
}
?>
</div> <!-- /container -->
</body>
</html>